<?php

function Docage_API_request($method,$url,$data='',$user='',$pass='', $contentType='application/json') : array {
    if(!$user) $user = $_SESSION['DocageApiUser'];
    if(!$pass) $pass = $_SESSION['DocageApiKey'];

    $response = array();

    $url = 'https://api.docage.com/'.$url;
    if ($method === "GET") {
        $args = array(
            'timeout' => 10000,
            'headers' => array(
                'Authorization' => 'Basic ' . base64_encode( $user . ':' . $pass )
            )
        );

        $remote_get = wp_remote_get( $url, $args );

        //$response[] = $remote_get['response']['code'];
        if (!is_wp_error($remote_get)) {
            $response[] = $remote_get['response']['code'];
            $response[] = json_decode(wp_remote_retrieve_body($remote_get));
        } else {
            echo '<pre>';
            var_dump($url);
            var_dump($remote_get);
            echo '</pre>';
            die();
        }
    } elseif ($method === "POST") {
        $data = wp_json_encode( $data );

        $args = [
            'body'        => $data,
            'headers'     => [
                'Authorization' => 'Basic ' . base64_encode( $user . ':' . $pass ),
                'Content-Type' => $contentType,
            ],
            'timeout'     => 10000,
            'redirection' => 5,
            'blocking'    => true,
            'httpversion' => '1.1',
            'sslverify'   => false,
            'data_format' => 'body',
        ];

        $response[] = wp_remote_post( $url, $args )['response']['code'];
        $response[] = json_decode(wp_remote_retrieve_body(wp_remote_post( $url, $args ) ));
    } elseif ($method == "PUT") {
        $data = wp_json_encode( $data );

        $args = [
            'body'        => $data,
            'headers'     => [
                'Authorization' => 'Basic ' . base64_encode( $user . ':' . $pass ),
                'Content-Type' => $contentType,
            ],
            'timeout'     => 10000,
            'redirection' => 5,
            'blocking'    => true,
            'httpversion' => '1.1',
            'sslverify'   => false,
            'data_format' => 'body',
            'method'	  => 'PUT'
        ];

        $response[] = wp_remote_request( $url, $args )['response']['code'];
        $response[] = json_decode(wp_remote_retrieve_body(wp_remote_request( $url, $args ) ));
    }

    return $response;
}