<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/toastify-js"></script>

<script>
    // Variables initialisation
    // Datas from PHP session
    let transactionProperties;
    let transactionMemberProperties;
    /*let transactionFileProperties;*/
    let docageTemplates;
    let wpForms;
    let bindings;

    let transactionCustomFields;
    let contactCustomFields;

    // Infos for binding
    let tableRowNumber = 0;

    // Other infos
    let language = '<?= $_SESSION["lang"] ?>';

    <?php if($_SESSION['is_authenticated'] === true) { ?>
    transactionProperties = JSON.parse(`<?= json_encode($_SESSION['transactionProperties']); ?>`);
    transactionMemberProperties = JSON.parse(`<?= json_encode($_SESSION['transactionMemberProperties']); ?>`);
    /*transactionFileProperties = JSON.parse('<?= json_encode($_SESSION['transactionFileProperties']); ?>');*/
    docageTemplates = JSON.parse(`<?= json_encode($_SESSION['transaction_templates']); ?>`);
    wpForms = JSON.parse(`<?= json_encode($_SESSION['wpforms_array']); ?>`);
    bindings = JSON.parse(`<?= json_encode($_SESSION['bindings_array']); ?>`);

    transactionCustomFields = JSON.parse(`<?= json_encode($_SESSION['transactionCustomFields']); ?>`);
    contactCustomFields = JSON.parse(`<?= json_encode($_SESSION['contactCustomFields']); ?>`);
    <?php } ?>

    // when we select a WPForm on the form select
    function onFormSelection(selectedValue) {
        sessionStorage.setItem("WPFormId", selectedValue);
        tableRowNumber = 0;

        // change the value of Docage template select to default
        jQuery("#docage_template_select option[value='default']").prop('selected', true);

        // clear the previous form infos
        jQuery("#binding_table").replaceWith(
            "<table id='binding_table' class='styled-table'>" +
            "<thead>" +
            "<tr>" +
            <?php switch ($_SESSION['lang']) {
            case 'FR': ?>
            "<th>Champs du formulaire</th>" +
            "<th>Objets du modèle</th>" +
            "<th>Propriétés modifiables</th>" +
            <?php break;

            case 'EN': ?>
            "<th>Form fields</th>" +
            "<th>Template objects</th>" +
            "<th>Editable properties</th>" +
            <?php break;

            case 'ES': ?>
            "<th>Campos de formulario</th>" +
            "<th>Objetos de plantilla</th>" +
            "<th>Propiedades editables</th>" +
            <?php break;
            } ?>
            "</tr>" +
            "</thead>" +
            "</table>"
        );

        // get all fields from the corresponding WPForm to create a row for each field
        wpForms.forEach(function (form) {
            if (form.Id == selectedValue) {
                form.WPFormFields.forEach(function (field) {
                    tableRowNumber++;
                    let cleanFieldLabelRegex = /^[^a-z]+|[^\w.-]+/gi;
                    let cleanFieldLabel = field.Label.replace(cleanFieldLabelRegex, "");
                    jQuery('#binding_table').append("<tr id='table_row_" + tableRowNumber + "'>" +
                        "<td class='wpform_field' id='wpform_field_" + tableRowNumber + "_" + cleanFieldLabel + "_" + field.Type + "'>" + field.Label + ' (' + field.Type + ')' + "</td><td class='template_object' id='template_object_" + tableRowNumber + "'></td><td id='object_property_" + tableRowNumber + "' class='object_property'></td>" +
                        "</tr>");
                });
                if (form.WPFormFields.length === 0)
                    showErrorNotification("Aucun champ n'a été trouvé pour ce WPForms, veuillez renseigner des champs valides.");
            }
        });
    }

    // when we select a Docage template on the template select
    function onTemplateSelection(selectedValue) {
        sessionStorage.setItem("templateId", selectedValue);

        for (i = 1; i <= tableRowNumber; i++) {
            // clear the previous template infos
            jQuery("#template_object_" + i).replaceWith("<td class='template_object' id='template_object_" + i + "'><select class='template_object_select'></select></td>");
            jQuery("#object_property_" + i).replaceWith("<td class='object_property' id='object_property_" + i + "'><select class='object_property_select'></select></td>");
        }

        // find corresponding template in the Docage template list
        let template;
        docageTemplates.forEach(function (docageTemplate) {
            if (docageTemplate.Id === selectedValue) template = docageTemplate;
        });

        let templateObjectSelect = jQuery(".template_object_select");
        let objectPropertySelect = jQuery(".object_property_select");

        // fill the columns for each row:
        // first the template object cells
        templateObjectSelect.append("<optgroup label='Défaut'><option value='None'>Aucun</option></optgroup>");
        templateObjectSelect.append("<optgroup label='Transaction'><option value='Transaction'>" + template.Name + "</option></optgroup>");
        templateObjectSelect.append("<optgroup label='TransactionMember'>");
        // when we have finished with transaction members, to change category in select options
        let isInTransactionMemberGroup = true;
        let isInTransactionFileGroup = false;
        template.Members.forEach(function (member) {
            if (member.Type !== "TransactionMember") isInTransactionMemberGroup = false;
            if (!isInTransactionMemberGroup && !isInTransactionFileGroup) {
                templateObjectSelect.append("</optgroup>");
                templateObjectSelect.append("<optgroup label='TransactionFile'>");
            }
            templateObjectSelect.append("<option value='" + member.Type + "_" + member.Name + "'>" + member.Name + "</option>");
            if (member.Type === "TransactionFile") isInTransactionFileGroup = true;
        });
        templateObjectSelect.append("</optgroup>");

        let bindingAlreadyExisting = false;

        // check all existing bindings to check if some already exists between this form and this template
        // if no binding exists, default selection is None
        bindings.forEach(function (binding) {
            if (binding.FormId === sessionStorage.getItem("WPFormId") && binding.TemplateId === sessionStorage.getItem("templateId")) {
                // find the row in the table that corresponding the binding
                let bindingRow;
                let cleanFormFieldName = binding.FormFieldName.replaceAll(" ", "-").replaceAll("(", "").replaceAll(")", "").replaceAll("'", "").replaceAll("\"", "");
                for (i = 1; i <= tableRowNumber; i++) {
                    if (jQuery("#wpform_field_" + i + "_" + cleanFormFieldName + "_" + binding.FormFieldType).length > 0) {
                        bindingRow = i;
                    }
                }

                if (binding.TemplateObjectType !== "Transaction") {
                    jQuery("#template_object_" + bindingRow + " .template_object_select option[value='" + binding.TemplateObjectType + "_" + binding.TemplateObjectName + "']").prop("selected", true);
                    // If template object is a TransactionMember
                    if (binding.TemplateObjectType === "TransactionMember") {
                        jQuery("#object_property_" + bindingRow + " .object_property_select").append("<optgroup label='Champs'>");
                        transactionMemberProperties.forEach(function (property) {
                            jQuery("#object_property_" + bindingRow + " .object_property_select").append("<option value='" + property.Key + "'>" + property.Label + "</option>");
                        });
                        if (contactCustomFields.length > 0) {
                            jQuery("#object_property_" + bindingRow + " .object_property_select").append("</optgroup><optgroup label='Champs personnalisés'>");
                            contactCustomFields.forEach(function (field) {
                                jQuery("#object_property_" + bindingRow + " .object_property_select").append("<option value='custom-" + field.name + "'>" + field.label + "</option>");
                            });
                        }
                        jQuery("#object_property_" + bindingRow + " .object_property_select").append("</optgroup>");
                    }
                    // If template object is a TransactionFile the only possible property to choose is File
                    else if (binding.TemplateObjectType === "TransactionFile")
                        jQuery("#object_property_" + bindingRow + " .object_property_select").append("<option value='File'>File</option>");
                } else {
                    jQuery("#template_object_" + bindingRow + " .template_object_select option[value='Transaction']").prop("selected", true);
                    jQuery("#object_property_" + bindingRow + " .object_property_select").append("<optgroup label='Champs'>");
                    transactionProperties.forEach(function (property) {
                        jQuery("#object_property_" + bindingRow + " .object_property_select").append("<option value='" + property.Key + "'>" + property.Label + "</option>");
                    });
                    if (transactionCustomFields.length > 0) {
                        jQuery("#object_property_" + bindingRow + " .object_property_select").append("</optgroup><optgroup label='Champs personnalisés'>");
                        transactionCustomFields.forEach(function (field) {
                            jQuery("#object_property_" + bindingRow + " .object_property_select").append("<option value='custom-" + field.name + "'>" + field.label + "</option>");
                        });
                    }
                    jQuery("#object_property_" + bindingRow + " .object_property_select").append("</optgroup>");
                }
                jQuery("#object_property_" + bindingRow + " .object_property_select option[value='" + binding.TemplateObjectProperty + "'").prop("selected", true);
                bindingAlreadyExisting = true;
            }
        });

        if (bindingAlreadyExisting === false) {
            jQuery("td[id^='object_property']").css("pointer-events", "none");
            jQuery("td[id^='object_property'] select").css("border-color", "lightgrey");
        }
    }

    // when we select a template object
    function onTemplateObjectSelectedInARow(rowNumber, propertyType) {
        // find the object property select at the good row
        let objectPropertySelect = jQuery("#object_property_" + rowNumber + " .object_property_select");
        objectPropertySelect.replaceWith("<select class='object_property_select'></select>");

        if (propertyType.toString() === "None") {
            jQuery("td[id^='object_property_" + rowNumber +"']").css("pointer-events", "none");
            jQuery("td[id^='object_property_" + rowNumber +"'] select").css("border-color", "lightgrey");
        } else {
            jQuery("td[id^='object_property_" + rowNumber +"']").css("pointer-events", "initial");
            jQuery("td[id^='object_property_" + rowNumber +"'] select").css("border-color", "#8c8f94");
        }
        
        // need to redifine or don't recognize the object
        objectPropertySelect = jQuery("#object_property_" + rowNumber + " .object_property_select");
        if (propertyType.toString() === "Transaction") {
            objectPropertySelect.append("<optgroup label='Champs'>");
            transactionProperties.forEach(function (property) {
                objectPropertySelect.append("<option value='" + property.Key + "'>" + property.Label + "</option>");
            });
            if (transactionCustomFields.length > 0) {
                objectPropertySelect.append("</optgroup><optgroup label='Champs personnalisés'>");
                transactionCustomFields.forEach(function (field) {
                    objectPropertySelect.append("<option value='custom-" + field.name + "'>" + field.label + "</option>");
                });
            }
            objectPropertySelect.append("</optgroup>");
        } else if (propertyType.toString() === "TransactionMember") {
            objectPropertySelect.append("<optgroup label='Champs'>");
            transactionMemberProperties.forEach(function (property) {
                objectPropertySelect.append("<option value='" + property.Key + "'>" + property.Label + "</option>");
            });
            // Custom fields part
            if (contactCustomFields.length > 0) {
                objectPropertySelect.append("</optgroup><optgroup label='Champs personnalisés'>");
                contactCustomFields.forEach(function (field) {
                    objectPropertySelect.append("<option value='custom-" + field.name + "'>" + field.label + "</option>");
                });
            }
            objectPropertySelect.append("</optgroup>");
        } else if (propertyType.toString() === "TransactionFile") {
            /*transactionFileProperties.forEach(function (property) {
                objectPropertySelect.append("<option value ='" + property.Key + "'>" + property.Label + "</option>");
            });*/
            objectPropertySelect.append("<option value ='File'>File</option>");
        }
    }

    function saveBindings() {
        let bindingsToAdd = [];

        for (i = 1; i <= tableRowNumber; i++) {
            let bindingToAdd = {};
            let tableRow = jQuery("#table_row_" + i);
            let rowFormFieldCell = tableRow[0].cells[0];
            let templateObjectSelect = jQuery("#template_object_" + i + " .template_object_select");
            let objectPropertySelect = jQuery("#object_property_" + i + " .object_property_select");

            bindingToAdd.FormId = sessionStorage.getItem("WPFormId");
            bindingToAdd.TemplateId = sessionStorage.getItem("templateId");
            bindingToAdd.FormFieldType = (rowFormFieldCell.id.split("_"))[4];
            bindingToAdd.FormFieldName = (rowFormFieldCell.id.split("_"))[3];
            bindingToAdd.TemplateObjectType = (templateObjectSelect[0].selectedOptions[0].value.split("_"))[0];
            if (bindingToAdd.TemplateObjectType === "None")
                continue;
            if (bindingToAdd.TemplateObjectType !== "Transaction")
                bindingToAdd.TemplateObjectName = (templateObjectSelect[0].selectedOptions[0].value.split("_"))[1];
            else
                bindingToAdd.TemplateObjectName = templateObjectSelect[0].selectedOptions[0].innerText;
            bindingToAdd.TemplateObjectProperty = objectPropertySelect[0].selectedOptions[0].value;

            bindingsToAdd.push(bindingToAdd);
        }

        jQuery("#home_binding_section").addClass("div-disabled");

        //for some url issues on different WP installations
        let url = '<?= plugins_url("save_bindings.php", dirname(__FILE__)) ?>';
        let pluginUrl = '<?= plugins_url("", dirname(__FILE__)) ?>';
        if (pluginUrl.endsWith("/docage") === false)
            url = '<?= plugins_url("docage/save_bindings.php", dirname(__FILE__)) ?>';

        jQuery.ajax({
            url: url,
            type: 'POST',
            data: {bindingsToAdd: bindingsToAdd},
            success: function(res) {
                showNotification("Les liaisons entre le WPForm et le modèle de transaction Docage ont été ajoutées avec succès.");
                setTimeout(() => { location.reload(); }, 3000);
            },
            error: function(err) {
                showErrorNotification(err.responseText);
            }
        });
    }

    function deleteBindings() {


        let formIdFromSession = sessionStorage.getItem("WPFormId");
        let templateIdFromSession = sessionStorage.getItem("templateId");

        // clear session before deleting
        sessionStorage.removeItem("WPFormId");
        sessionStorage.removeItem("templateId");

        jQuery("#home_binding_section").addClass("div-disabled");

        //for some url issues on different WP installations
        let url = '<?= plugins_url("delete_bindings.php", dirname(__FILE__)) ?>';
        let pluginUrl = '<?= plugins_url("", dirname(__FILE__)) ?>';
        if (pluginUrl.endsWith("/docage") === false)
            url = '<?= plugins_url("docage/delete_bindings.php", dirname(__FILE__)) ?>';

        jQuery.ajax({
            url: url,
            type: 'POST',
            data: {bindingsToDeleteInfos: {formId: formIdFromSession, templateId: templateIdFromSession}},
            success: function(res) {
                showNotification("Les liaisons entre le WPForm et le modèle de transaction Docage ont été supprimées avec succès.");
                setTimeout(() => { location.reload(); }, 3000);
            },
            error: function(err) {
                showErrorNotification(err.responseText);
            }
        });
    }

    function abortTransaction(transactionId) {
        return new Promise((resolve, reject) => {
            jQuery.ajax({
                type: "GET",
                url: "localhost:5000/Transactions/Abort/" + transactionId,
                beforeSend: function (xhr) {
                    xhr.setRequestHeader("Authorization", "Basic " + btoa('<?= $_SESSION["DocageApiUser"] ?>' + ":" + '<?= $_SESSION["DocageApiKey"] ?>'));
                },
                success: function (result) {
                    resolve(result);
                },
                error: function (err) {
                    reject(err.responseText);
                }
            })
        });
    }

    function sendRemindersToTransaction(transactionId) {
        return new Promise((resolve, reject) => {
            jQuery.ajax({
                type: "GET",
                url: "localhost:5000/Transactions/SendReminders/" + transactionId,
                beforeSend: function (xhr) {
                    xhr.setRequestHeader("Authorization", "Basic " + btoa('<?= $_SESSION["DocageApiUser"] ?>' + ":" + '<?= $_SESSION["DocageApiKey"] ?>'));
                },
                success: function (result) {
                    resolve(result);
                },
                error: function (err) {
                    reject(err.responseText);
                }
            })
        });
    }

    function showHomeTab() {
        jQuery("#transactions_container").hide();
        jQuery("#infos_container").hide();
        jQuery("#home_container").show();
    }

    function showTransactionsTab() {
        jQuery("#home_container").hide();
        jQuery("#infos_container").hide();
        jQuery("#transactions_container").show();
    }

    function showInfosTab() {
        jQuery("#home_container").hide();
        jQuery("#transactions_container").hide();
        jQuery("#infos_container").show();
    }

    function showNotification(notificationText) {
        Toastify({
            text: notificationText,
            duration: 3000,
            close: true,
            gravity: "bottom", // `top` or `bottom`
            position: "center", // `left`, `center` or `right`
            backgroundColor: "#a0dc3c",
            stopOnFocus: true, // Prevents dismissing of toast on hover
            onClick: function () {
            }, // Callback after click
        }).showToast();
    }

    function showErrorNotification(errorMessage) {
        Toastify({
            text: "Error: " + errorMessage,
            duration: 3000,
            close: true,
            gravity: "bottom", // `top` or `bottom`
            position: "center", // `left`, `center` or `right`
            backgroundColor: "#ff4d51",
            stopOnFocus: true, // Prevents dismissing of toast on hover
            onClick: function () {
            }, // Callback after click
        }).showToast();
    }

    jQuery(document).ready(function () {
        // Check if there's success toast to display
        <?php if($_SESSION["bindingAddOk"] == true) { ?>
            showNotification("Les liaisons entre le WPForm et le modèle de transaction Docage ont été ajoutées avec succès.");
            setTimeout(() => { location.reload(); }, 3000);
        <?php
        unset($_SESSION['bindingAddOk']);
        } ?>
        <?php if($_SESSION["bindingDeleteOk"] == true) { ?>
        showNotification("Les liaisons entre le WPForm et le modèle de transaction Docage ont été supprimées avec succès.");
        setTimeout(() => { location.reload(); }, 3000);
        <?php
        unset($_SESSION['bindingDeleteOk']);
        } ?>

        // Tabs change
        jQuery("#home_tab_display").on("click", function (e) {
            e.preventDefault();
            showHomeTab();
        });
        jQuery("#transactions_tab_display").on("click", function (e) {
            e.preventDefault();
            showTransactionsTab();
        });
        jQuery("#infos_tab_display").on("click", function (e) {
            e.preventDefault();
            showInfosTab();
        });

        // If user is authenticated
        <?php if($_SESSION['is_authenticated'] === true) { ?>
        // When changing the value of WPForm select
        jQuery("#wpform_select").on('change', function (e) {
            onFormSelection(e.target.value);
        });

        // When changing the value of Docage template select
        jQuery("#docage_template_select").on('change', function (e) {
            onTemplateSelection(e.target.value);
        });

        // When changing a select on transaction object column
        jQuery(document).on("change", ".template_object_select", function (e) {
            let rowNumber = (e.target.parentElement.id.split("_"))[2];
            let propertyType = (e.target.selectedOptions[0].value.split("_"))[0];
            onTemplateObjectSelectedInARow(rowNumber, propertyType);
        });

        // When clicking on save bindings button
        jQuery("#save_bindings_button").on("click", function () {
            if (sessionStorage.getItem("WPFormId") !== "default" && sessionStorage.getItem("WPFormId") !== null &&
                sessionStorage.getItem("templateId") !== "default" && sessionStorage.getItem("templateId") !== null)
                saveBindings();
        });

        // When clicking on delete bindings button
        jQuery("#delete_bindings_button").on("click", function () {
            if (sessionStorage.getItem("WPFormId") !== "default" && sessionStorage.getItem("WPFormId") !== null &&
                sessionStorage.getItem("templateId") !== "default" && sessionStorage.getItem("templateId") !== null)
                deleteBindings();
        });

        // When clicking on abort in the transactions tab
        jQuery(".transaction_abort_button").on("click", function (e) {
            let transactionId = e.target.id.replace("transaction_abort_button_", "");
            abortTransaction(transactionId).then((result) => {
                showNotification("Transaction annulée avec succès.");
                setTimeout(() => { location.reload(); }, 3000);
            })
                .catch((err) => {
                    showErrorNotification(err.responseText);
                })
        });

        // When clicking on send reminder button in the transactions tab
        jQuery(".transaction_send_reminders_button").on("click", function (e) {
            let transactionId = e.target.id.replace("transaction_send_reminders_button_", "");
            sendRemindersToTransaction(transactionId).then((result) => {
                showNotification("Rappel bien envoyés aux membres de la transaction");
            })
                .catch((err) => {
                    showErrorNotification(err.responseText);
                })
        });
        <?php } ?>
    });
</script>